package dev.shadowsoffire.apotheosis.ench.replacements;

import net.minecraft.world.effect.MobEffectInstance;
import net.minecraft.world.effect.MobEffects;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.item.enchantment.Enchantments;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.world.entity.MobType;
import net.minecraft.world.item.enchantment.DamageEnchantment;

public class BaneEnchant extends DamageEnchantment
{
    protected final MobType attrib;
    
    public BaneEnchant(final Enchantment.Rarity rarity, final MobType attrib, final EquipmentSlot... slots) {
        super(rarity, 0, slots);
        this.attrib = attrib;
    }
    
    public int m_6183_(final int level) {
        if (this.attrib == MobType.f_21640_) {
            return 1 + (level - 1) * 11;
        }
        return 5 + (level - 1) * 8;
    }
    
    public int m_6175_(final int level) {
        return this.m_6183_(level) + 20;
    }
    
    public int m_6586_() {
        return 5;
    }
    
    public float m_7335_(final int level, final MobType attrib) {
        if (this.attrib == MobType.f_21640_) {
            return 1.0f + level * 0.5f;
        }
        if (this.attrib == attrib) {
            return level * 1.5f;
        }
        return 0.0f;
    }
    
    public boolean m_5975_(final Enchantment ench) {
        if (this.attrib == MobType.f_21640_) {
            return ench != this;
        }
        return (ench == Enchantments.f_44977_) ? (ench != this) : (!(ench instanceof BaneEnchant));
    }
    
    public void m_7677_(final LivingEntity user, final Entity target, final int level) {
        if (target instanceof final LivingEntity livingentity) {
            if (this.attrib != MobType.f_21640_ && livingentity.m_6336_() == this.attrib) {
                final int i = 20 + user.m_217043_().m_188503_(10 * level);
                livingentity.m_7292_(new MobEffectInstance(MobEffects.f_19597_, i, 3));
            }
        }
    }
}
